


#include <kos.h>


volatile unsigned long *snd_dbg = (unsigned long*)0xa080ffc0;

#include "s3mplay.h"

int play_s3m(char *fn) {
	int idx, r;
	uint32 fd;
	unsigned char buffer[2048];

	spu_disable();

	printf("Loading %s\r\n", fn);
	fd = fs_open(fn, O_RDONLY);
	if (fd == 0) {
		printf("Can't open file %s\r\n", fn);
		return 0;
	}

	idx = 0x10000;
	/* Load 2048 bytes at a time */
	while ( (r=fs_read(fd, buffer, 2048)) > 0) {
		spu_memload(idx, buffer, r);
		idx += r;
	}
	fs_close(fd);

	/* Switch channels to mono if holding down A */
	/*if (check_for_btn(BTN_A)) {
		snd_dbg[1] = 1;
	} else {
		snd_dbg[1] = 0;
	}*/

	//dc_serial_printf("Load OK, starting ARM\r\n");
	printf("Loading ARM program\r\n");
	spu_memload(0, s3mplay, sizeof(s3mplay));

	printf("arm program size %d - buffer %d \n",sizeof(s3mplay),sizeof(buffer));

	printf("Start\r\n");
	spu_enable();

	while (*snd_dbg != 3)
		;

	while (*snd_dbg == 3)
		;

	printf("s3m loaded Done\r\n");

	return 1;
}


void play_s3mstop()
{
  spu_disable();
}
